# GP toolbox

Blender addon - Boîte a outils de grease pencil pour la production d'animation.

**[Télécharger la dernière version](https://gitlab.com/autour-de-minuit/blender/GP_toolbox/-/archive/master/GP_toolbox-master.zip)**

> Une fois en place un système de mise a jour facilité est accessible dans les préférence (La vérification automatique dde nouvelle mise a jour peut y être activé)

Il est recommandé de désactiver l'addon natif "Grease pencil tools" car ces outils sont déjà intégré dans la toolbox et risque de créer des conflit.

## Fonctionnalités et détails


### Exposition dans l'UI de fonction native

Exposition de certains attribut déjà existant utiles mais trop "loins" dans l'interface

Expose les options suivantes:

- Zoom 1:1 - Vue en cam prend le zoom 100% en fonction de la résolution (ops `view3d.zoom_camera_1_to_1`)
- Zoom fit - Ajuste la vue pour que la cam soit vue en totalité dans l'écran (ops `view3d.view_center_camera`)
- Onion skin - coche des overlays
- autolock layer - coche du sous-menu de l'UI list des layers
- X-ray - Option `In Front` dans les propriété de l'objet
- passepartout de caméra - active-désactive + opactité
- liste de boutons pour activer/désactiver les background de caméra (tous ou individuellement) avec icone par type.

**Edit line opacity** - Il est en réalité pratique de pouvoir cacher l'edit line pour avoir un meilleur aperçu du rendu lors du sculpt par exemple. C'est une option lié au layer. Ce slider appelle une fonction pour affecter tout les layers de tout les objets au lieu de se cantonner au layer courant.


### Tools principaux d'anim:


**Système de Main cam VS draw cam / action cam** : pour permettre le roll du viewport quand on est en vue caméra (sans affecter la caméra def du layout) la draw cam peut être activée. c'est simplement une duplication de la caméra principale (main) parenté a cette dernière et sur laquelle on peut se permettre de faire le roll via rotate canvas (Workaround tant que blender ne permet pas de roll la vue en cam).  

L'action cam (aurait du s'appeler follow_cam) fonctionne sur le principe que la draw sauf qu'elle se parente à l'objet selectionné. le but est de pouvoir suivre un objet en mouvement pour le dessiner en contitnue sans nécessairement désactiver les anims. Concrètement, cette dernière solution est plus clean et sans doute moins galère, c'est ce que les animateurs ont majoritairement utilisé.

**Rotate canvas** (`ctrl + alt + clic-droit`): différence avec celui intégré a grease pencil tools : la rotation en vue cam n'est possible que si on est dans une caméra de manipulation "manip_cam" pour éviter de caasser l'anim le roll de la cam principale.

**Box deform** (`Ctrl+T`) : Déformation 4 coins (Peut-être le retirer maintenant qu'il est dans le _Grease pencil tools_ pour éviter les conlfits/redondances, mais d'un autre côté la version intégrée peut éventeullement être customisée et corriger d'éventuel souci, sans attendre les updates de blender, a voir)

**GP keyframe jump** (raccourci a ajouter manuellement, tant qu'on a pas une keymap anim un minimum standard): Essentiel, permet d'ajouter une ou plusieurs paire de raccourcis pour aller de keyframe en keyframe (filtrage du saut personnalisable). le raccourci doit appeler l'operateur `screen.gp_keyframe_jump`, (en faire un second avec le next décoché pour faire un saut arrière)

**Breakdown en mode objet** (`Shift+E`) : Breakdown en pourcentage entre les deux keyframes (pose une clé si l’auto-key est actif et utilise le keying set si il est actif). Même comportement et raccourci que le breakdown de bones en pose mode (juste qu'il n'existait bizzarement pas en objet)


**Snap cursor** - Snap le curseur sur le canvas de GP (respecte les paramètres "tool setting" qui définit le comportement du canvas)
À placer dans la keymap manuellement pour le moment en utilisant l'id `view3d.cusor_snap` (original `view3d.cursor3d`)


**Playblast** - Create a playblast folder in the blend's folder.
in 0.8.0 normal playblast (file still within addon folder) was replaced by bg_playblast (adaptation of samy tichadou's playblaster)

**GP copy paste** - permet de copier coller les clés en dur.
TODO -> vérifier l'intégration. semble avoir des soucis.
Pas mal de l'avoir en addon séparé aussi vu  qu'il a son propre panel a lui. 

**check files** - série de check écris en dur dans le code. Pratique pour "fixer" rapidement sa scène:
- Lock main cam
- set scene res to def project res (specified in addon prefs)
- set scene percentage at 100:
- set show slider and sync range in opened dopesheet
- set fps to 24 (need generalisation with addonpref choice)
- set select cursor type (according to prefs ?)
- GP use additive drawing (else creating a frame in dopesheet makes it blank...)
- GP stroke placement/projection check (just warn if your not in 'Front')
- Warn if there are some disabled animation (and list datapath)
- Set onion skin filter to 'All type' (this became default in blender 2.91, guess who asked ;) )


### moins important

**Mirror flip X** - Applique simplement un `scale.x -1` sur la cam active (un petit indicateur s'affiche pour indiquer qu'on est en mirror, recliquer sur le bouton permet de rétablir le scale d'origine)


**Cursor Follow** - (Utilise un handler) : ubne fois activé, permet de faire suivre le curseur 3D sur un objet animé.
Souci connu: Il y a un décalage d'une frame une fois activé sur un nouvel objet, il suffit de le recaler une fois.

**Animation manager** - permet d'aciver/désactiver les anims d'objets de tout les objets ou de tout les 

### Présent mais pas utilisés:

**Sticky key tool** 
Les raccourci vers des tools temporaires sont très pratique, on peut facilement créer un raccourci qui appelle le tool durant la presion d'un bouton. Cet operator est un modal qui permet de faire la même chose mais en activant simplement le tool si la touche est rapide. (`OP_temp_cutter.py > GPTB_OT_sticky_cutter` idname : `wm.sticky_cutter`)


### À potentiellement mettre de côté/retirer:

**Tint layer** : Très peu utilisé, permet de mettre une teinte aléatoire par calque afin de les différencier rapidement. Souci de cet opérateurm, il ne faut pas l'utiliser si on utilise les tints de layer car il en change la couleur.

**Colorize** (gros WIP): un sous ensemble d'outils qui était censé permettre de faire du remplissage bitmap via des color spots en envoyant deux set d'images rendu automatiquement à GMIC en ligne de commande et recalé la séquence de résultat en BG de Cam. Finalement abandonné, pas eu le temps de finir la mise au point (malgré des résultats préliminaires intéressant).
Maistrop long a mettre en place, trop hackeu, et surtout c'est dommage de basculer sur du bitmap, la source de couleur doit rester au maximum GP/vecto.

## colorisation:

**Line stopper** - Extension des lignes dans un matériaux a part pour améliorer la fermeture des formes. le hack est très simple mais aide beaucoup a fermer les contour pour éviter le leak de l'outils pot de peinture.

**Create empty frame** - Permet de créer des frames vides sur un calques partout ou il y a des frames sur les calques supérieur (permet de faire un key to key sur le calque actif ensuite sur les key pré-créée pour faire sa colo). C'est pratique à utiliser.
En réalité pour quelque chose de plus pratique pour la colo, il suffit d'utiliser le `screen.gp_keyframe_jump` operator en activant le filtre (all layers) : TODO faire un "all layer _above_" ou se baser sur le nouveau filtre natif lié a cet usage depuis blender 2.91

**Render** chemin de sorties + 2 boutons
    - layers individually (popup pour selecitonner des layers a render individuellement)
    - layers grouped (popup pour selectionner des layers a rendre ensemble)
    - TODO -> Le chemin de base est défini en dur dans le project template  
    `blend.parents[1] / "compo" / "base" / obname / (obname+'_')`  
    -> Basculer vers un chemin personnalisable dans les préférences.
    TODO -> profiter du système de render layers (per layer) pour faire un meilleur batch renderer.


## tools supplémentaires

**check links** - (pop une fenêtre) permet de lister les liens de la scène, voir si il y en a des cassés et ouvrir le dossier d'un lien existant.


## raccourci supplémentaires

Sculpt mode:
    point/stroke filter shortcut sur `1`, `2`, `3` en toggle (similaire a l'edit mode)

cursor_GP
    Surcharge du raccourci curseur 3D pour le snapper à la surface du grease pencil.
    Raccourci à remplacer manuellement dans la keymap, Pas forcément utile si il n'y a un mix de 2D/3D
    Le mieux serait d'avoir un raccourci dédié, séparé de celui d'origine...

---

TODO:

- Permettre de rendre avec la résolution spécifié dans le nom de la caméra active
(utile dans les projet rendu a la résolution du BG mais ou la résolution finale peut être utilisé pour un bout-a-bout)

- Update du système de "passes" de rendu:
    - utiliser des render layers + file outputs au lieux de faire des batchs par opacité

- BG Playblast enhancement:
    - Tester davantage le playblast BG
    - Éventuellement mettre une coche de fallback vers le playblast classique (utile en cas de pépin.

- Faire un import-export des réglage généraux en json (Déjà une bonne partie du code dans Pipe sync)
pour set : Résolution du film, dossier palette, render settings 

- opt: exposer les "tool setting" de placement de canvas en permanence dans la sidebar (visible seulement en draw)

- Déplacer automatiquement la vue "Face" au GP (en fonction des Gpencil view settings)

- Déplacer les clés de dopesheet en même temps que les clés de GP (Déjà Créer par Tom Viguier sur [Andarta](https://gitlab.com/andarta-pictures)

- Meilleure table lumineuse (grosse réflexion et travail en perspective)